display.setStatusBar(display.HiddenStatusBar) 
local mRound = math.round 
local mRand = math.random 
local mAbs  = math.abs


local physics = require "physics"

physics.start()


display.newImage( "grafika/RoomTexture.png", 512, 384 )

local h1 = display.newImage( "arm6.png", 550, 550 )
local h2 = display.newImage( "arm5.png", 230, 200 )

h1:setFillColor( 0, 0, 1 )
h2:setFillColor( 0, 0, 1 )

h1.width = 200
h1.height= 200

h1.fRotation = 0

h2.width = 200
h2.height = 200

h2.fRotation = 0
h2.fExtraRotation = 0

-- napisy

local r = display.newRect( 820, 260, 260, 160 )
r:setFillColor( 0, 0.5 )
r.strokeWidth = 2
r:setStrokeColor( 0.2 )


local r = display.newImage( "spider.png", 730, 230 )
r.xScale = 0.5
r.yScale = 0.5

local spiderScore = display.newText( "x 0", 760, 230, native.systemFont, 20 )
spiderScore.anchorX = 0

r = display.newImage( "leaf.png", 730, 290 )
r.xScale = 0.6
r.yScale = 0.6

local leafScore = display.newText( "x 0", 760, 290, native.systemFont, 20 )
leafScore.anchorX = 0

local spiderX = display.newText( "Spider x: 0", 130, 130, native.systemFont, 20 )
-- local spiderY = display.newText( "Spider y: 0", 30, 160, native.systemFont, 20 )
-- spiderX.anchorX = 0
-- spiderY.anchorX = 0

local woda = display.newRect( 962, 420, 20, 140 )
woda:setFillColor( 0, 0, 0.8 )
woda.anchorY = 0
local kranik = display.newImage( "kran.png", 990, 400 )


local kubek = display.newImage( "kubek.png", 330, 245 )
kubek.xScale = 0.6
kubek.yScale = 0.6
kubek.fRotation = 0
kubek.fExtraRotation1 = 0
kubek.fExtraRotation2 = 0

local kubekLevel = display.newImage( "kubek.png", 880, 245 )

kubekLevel.xScale = 0.5
kubekLevel.yScale = 0.5

local wodaLevel = display.newRect( 880, 234, 38, 30 )
wodaLevel:setFillColor(0)
wodaLevel.anchorY = 0
kubek.level = 0

wodaLevel.height = (1 - kubek.level) * 26

local robot = display.newRect( 540, 550, 70, 150 )
-- local robot = display.newImage( "grafika/viader7.png", 540, 550 )
-- robot.xScale = 0.5
-- robot.yScale = 0.5
robot:setFillColor( 0.2, 0, 0.8 )

local arm = display.newGroup()

arm:insert( h1 )
arm:insert( h2 )

local spider = display.newImage( "spider.png", 200, -50 )
local spiderLine = display.newRect( 200, -55, 4, 10 )
spiderLine.anchorY = 0
spiderLine.anchorY = 0
spider.fScored = false
spider.score = 0


local leaf = display.newImage( "leaf.png", 500, 150 )
leaf.score = 0
leaf.fMoving = false
leaf.fScored = false

leaf.xStart = 500
leaf.yStart = 150
leaf.Vx = 0
leaf.Vy = 0
leaf.isVisible = false
leaf.fMoving = false
leaf.scopeX = 300


local cat = display.newImage( "cat.png", 200, 850 )
-- local cat = display.newImage( "kotek5.png", 200, 850 )
cat.xScale = 1.5
cat.yScale = 1.5

-- physics.addBody( cat, "dynamic", { density = 0.5  })
physics.addBody( cat, "dynamic" ) 

r = display.newImage( "cat.png", 730, 260 )
r.xScale = 0.4
r.yScale = 0.4

local catScore = display.newText( "x 0", 760, 260, native.systemFont, 20 )
catScore.anchorX = 0

cat.score = 0
cat.fScored = false



local podloga = display.newRect( 512, 900, 2424, 30 )

physics.addBody( podloga, "static")




local function h1Up( event )

	if event.phase == 'began' or event.phase == 'down' then 
		h1.fRotation = 1
		h2.fExtraRotation = h1.fRotation 
		kubek.fExtraRotation1 = 1
	elseif 	event.phase == 'ended' or event.phase == 'up' then 
		h1.fRotation = 0
		h2.fExtraRotation = 0
		kubek.fExtraRotation1 = 0
	end
	
	return true
																								
end

local function h1Down( event )

	if event.phase == 'began' or event.phase == 'down'then 
		h1.fRotation = -1
		h2.fExtraRotation = h1.fRotation 
		kubek.fExtraRotation1 = h1.fRotation 
	
	elseif 	event.phase == 'ended' or event.phase == 'up'  then 
		h1.fRotation = 0
		-- h2.fRotation = 0
		h2.fExtraRotation = 0
		kubek.fExtraRotation1 = 0
		
	end
	
	return true
	
end

local function h2Up( event )

	if event.phase == 'began' or event.phase == 'down' then 
		h2.fRotation = 1
		kubek.fExtraRotation2 = 1
	elseif 	event.phase == 'ended'  or event.phase == 'up' then 
		h2.fRotation = 0
		kubek.fExtraRotation2 = 0
	end
	
	return true
	
end

local function h2Down( event )

	if event.phase == 'began' or event.phase == 'down' then 
		h2.fRotation = -1

		kubek.fExtraRotation2 = -1
		
	elseif 	event.phase == 'ended'  or event.phase == 'up' then 
		h2.fRotation = 0
		kubek.fExtraRotation2 = 0
		
	end
	
	return true
	
end

local function h3Up( event )

	if event.phase == 'began' or event.phase == 'down' then 
		kubek.fRotation = 1
	elseif 	event.phase == 'ended'  or event.phase == 'up' then 
		kubek.fRotation = 0
	end
	
	return true
	
end

local function h3Down( event )

	if event.phase == 'began' or event.phase == 'down'  then 
		kubek.fRotation = -1
		
	elseif 	event.phase == 'ended'  or event.phase == 'up' then 
		kubek.fRotation = 0

	end
	
	return true
	
end

local kubekAlfa = display.newText( "0", 200, -130, native.systemFont, 20 )
local rozlane = display.newText( "ROZLANE", 200, 50, native.systemFont, 50 )
rozlane.isVisible = false


-- local stolik = display.newRect( 30, 550, 120, 10 )

local xMove = 0

local function xMoveChangeLeft( event )

	if ( event.phase == 'began' or event.phase == "down" ) then 
		xMove = -3 
	elseif event.phase == 'ended'  or event.phase == "up" then
		xMove = 0
	end	
	
end

local function xMoveChangeRight( event )

	if ( event.phase == 'began' or event.phase == "down" ) then 
		xMove = 3 
	elseif event.phase == 'ended'  or event.phase == "up" then
		xMove = 0
	end	
	
end

kubek.startY = 0

local fPlaying = false

local function updateFrame( event )

	
	-- h1.rotation = h1.rotation % 360 
	
	-- spiderX.text = mRound (mAbs( cat.y - kubek.y ))
	
	h1:rotate( h1.fRotation )
	h2:rotate( h2.fRotation + h2.fExtraRotation )
-- media.playSound( "sounds/fx/player/arm1-begin.wav" )		
	if ( h1.fRotation ~= 0 ) and ( not fPlaying ) then
		fPlaying = true
		-- media.playSound( "sounds/fx/player/arm2loop2.wav", onComplete = function() fPlaying = false end )		
	end	
	
	if h1.rotation > 10 then h1.rotation = 10 end
	if h2.rotation > 10 then h2.rotation = 10 end
	
	if h1.rotation < -190 then h1.rotation = -190 end
	if h2.rotation < -190 then h2.rotation = -190 end
	
	local h1cos = math.cos( h1.rotation * 3.14 / 180)
	local h1sin = math.sin( h1.rotation * 3.14 / 180)
	
	h2.x = h1.x + 73 * h1cos
	h2.y = h1.y + 73 * h1sin
	
	local h2cos = math.cos( h2.rotation * 3.14 / 180)
	local h2sin = math.sin( h2.rotation * 3.14 / 180)
	
	kubek.x = h2.x + 90 * h2cos  
	kubek.y = h2.y + 90 * h2sin 
	
	if kubek.startY == 0 then kubek.startY = kubek.y end
	
	-- kubek:rotate( kubek.fRotation + kubek.fExtraRotation1 + kubek.fExtraRotation2 )
	
	kubekAlfa.text = kubek.rotation

	if math.abs( kubek.rotation ) > 30 then 
		rozlane.isVisible = true
	end	
	
	robot.x = robot.x + xMove
	if robot.x > 800 then 
		robot.x = 800
	elseif robot.x < 200 then
		robot.x = 200
	else	
	
		
		
		h1.x = h1.x + xMove
		h2.x = h2.x + xMove
		kubek.x = kubek.x + xMove
	
	end
	
	-- spiderX.text = "Spider x: " .. mRound( spider.x )
	-- spiderY.text = "Spider y: " .. mRound( spider.y )
	
	if ( not spider.fScored ) then
	
		if ( mAbs(spider.x - kubek.x ) < 30 ) and ( mAbs( spider.y - kubek.y ) < 30 ) then
			spider.fScored = true
			spider.score = spider.score + 1
			spiderScore.text = "x " .. spider.score
			spider.isVisible = false
			spiderLine.isVisible = false
		
		end
	
	end
	
	if not cat.fScored then
	
		if ( mAbs(cat.x - kubek.x ) < 40 ) and ( mAbs( cat.y - kubek.y ) < 60 ) then
			cat.fScored = true
			cat.score = cat.score + 1
			if kubek.level > 0 then kubek.level = kubek.level - 0.25 end
			catScore.text = "x " .. cat.score
		end	
	
	end
	
	
	if leaf.fMoving then
	
		leaf.x = leaf.x + leaf.Vx
		leaf.y = leaf.y + leaf.Vy
		leaf.rotation = leaf.rotation + leaf.Vr	
		
		if mAbs( leaf.x - leaf.xStart ) > leaf.scopeX then
		
			leaf.Vx = - leaf.Vx
			leaf.xStart = leaf.x
			leaf.ScopeX = mRand( 200, 600 )
			-- leaf.Vr = -leaf.Vr
		
		end
		
		if ( mAbs( leaf.x - kubek.x ) < 20 ) and ( mAbs( leaf.y - kubek.y ) < 10 ) then 
		
			leaf.score = leaf.score + 1
			leafScore.text = "x " .. leaf.score
			leaf.fMoving = false
			leaf.isVisible = false
		
		end
		
		if leaf.y > 800 then
			leaf.fMoving = false
	
		end
	end
	
	if mAbs( kubek.x - kranik.x + 32 ) < 10 then
		woda.isVisible = true
		woda.height = kubek.y - woda.y + 10
		kubek.level = 1
	else
		woda.isVisible = false
	end	
			
	
	wodaLevel.height = (1 - kubek.level) * 30
	
end

local h1l = display.newRect( 20, 700, 20, 20 )
local h1u = display.newRect( 20, 670, 20, 20 )

h1l:addEventListener( "touch", h1Up )
h1u:addEventListener( "touch", h1Down )

local h2l = display.newRect( 50, 700, 20, 20 )
local h2u = display.newRect( 50, 670, 20, 20 )

h2l:addEventListener( "touch", h2Up )
h2u:addEventListener( "touch", h2Down )

local h3l = display.newRect( 80, 700, 20, 20 )
local h3u = display.newRect( 80, 670, 20, 20 )

h3l:addEventListener( "touch", h3Up )
h3u:addEventListener( "touch", h3Down )

local h4l = display.newRect( 110, 700, 20, 20 )
local h4u = display.newRect( 110, 670, 20, 20 )

h4l:addEventListener( "touch", xMoveChangeLeft )
h4u:addEventListener( "touch", xMoveChangeRight )


local function processSpider()

	
	spider.fScored = false
	spider.isVisible = true
	spiderLine.isVisible = true
	spider.y = -40
	spider.x = kubek.x
	spider.zasieg = kubek.y + 50
	
	spiderLine.x = spider.x - 2
	spiderLine.height = 10
	
	transition.to( spider, { y = spider.y + 0.15 * spider.zasieg, time = 120 } )
	transition.to( spiderLine, { height = 10+ 0.15 * spider.zasieg, time = 120 } )
	
	transition.to( spider, { y = spider.y + spider.zasieg, time = 800, delay = 500 } )
	transition.to( spiderLine, { height = 10 + spider.zasieg, time = 800, delay = 500 } )
	
	transition.to( spider, { y = -40, time = 1500, delay = 4000 } )
	transition.to( spiderLine, { height = 10, time = 1500, delay = 4000 } )
	

end

local function processLeaf()

	leaf.x = 500
	leaf.xStart = 500
	leaf.y = leaf.yStart
	leaf.fMoving = true
	leaf.isVisible = true
	leaf.xScope = mRand( 50, 150 )
	leaf.Vx = 2
	-- leaf.Vy = 0.5
	leaf.Vy = 1
	leaf.Vr = 1
	leaf.fScored = false

end

local function catPhase2()

	
	-- transition.to( cat, { x = cat.targetX, y = cat.targetY, time = 300, transition = easing.continuousLoop } )
	-- transition.to( cat, { x = cat.targetX, y = cat.targetY, time = 300, onComplete = function() print( cat.x) end } )
	
	-- transition.to( cat, { x = cat.x + 300, y = 780, time = 300, delay = 510 } )
	-- transition.to( cat, { delay = 300, x = 2*cat.targetX - cat.x, y = 780, time = 300 } )
	local modyf = ( kubek.startY - kubek.y ) / 200
	print( modyf )
	cat:applyLinearImpulse( 1.7 + modyf, 2.7 + modyf, cat.x, cat.y )
	timer.performWithDelay( 60, function() cat.isVisible = true end )
	-- timer.performWithDelay( 2500, function() cat.isVisible = false end )
	
end

local function catPhase1()
	
	-- transition.to( cat, { y = 780, time = 200 } )
	-- cat.targetX = kubek.x
	-- cat.targetY = kubek.y
	
	-- cat:setLinearVelocity( 0, 20 )
	
	
	cat:applyLinearImpulse( 0, 1.2, cat.x, cat.y )
	timer.performWithDelay( 60, function() cat.isVisible = true end )
	
end


local function processCat()

	
	cat.fScored = false
	cat.isVisible = true
	cat:setLinearVelocity( 0, 0) 
	-- cat.y = 800
	local modyf = ( kubek.startY - kubek.y ) / 2
	cat.x = kubek.x - 300 - modyf

	catPhase1()
	timer.performWithDelay( 1500, catPhase2 )

	
	
end


local keyOpis = display.newText( "key1", 200, -100, native.systemFont, 20 )

local function onKeyEvent(event)

	keyOpis.text = event.keyName
	
	local key = event.keyName
	
	if key == 'down' then
		h1Up( event )
	elseif key == 'up' then
		h1Down(event)
	elseif key == 's' then
		h2Up( event )
	elseif key == 'w' then
		h2Down(event)
	elseif key == 'o' then
		h3Up( event )
	elseif key == 'p' then
		h3Down(event)
	elseif key == 'left' then
		xMoveChangeLeft(event)
	elseif key == 'right' then
		xMoveChangeRight(event)
	end
	
	return false

end

local function onCollision( event )


	cat.isVisible = false

end

processSpider()
timer.performWithDelay( 10000, processSpider, 0 )

processLeaf()
timer.performWithDelay( 15000, processLeaf, 0 )

timer.performWithDelay( 2000, processCat )
timer.performWithDelay( 11000, processCat, 0 )

Runtime:addEventListener( "enterFrame", updateFrame )
Runtime:addEventListener( "key", onKeyEvent )
Runtime:addEventListener( "collision", onCollision )

